Index: modules/misc/rtsp.c
===================================================================
--- modules/misc/rtsp.c	(revision 15362)
+++ modules/misc/rtsp.c	(working copy)
@@ -92,6 +92,9 @@
     vlc_bool_t b_playing; /* is it in "play" state */
     vlc_bool_t b_paused; /* is it in "pause" state */
 
+    char *psz_ip;
+    int i_port;
+
     int i_es;
     rtsp_client_es_t **es;
 
@@ -640,6 +643,8 @@
 
     TAB_REMOVE( p_media->i_rtsp, p_media->rtsp, p_rtsp );
 
+    if( p_rtsp->psz_ip ) free( p_rtsp->psz_ip );
+
     free( p_rtsp->psz_session );
     free( p_rtsp );
 }
@@ -689,14 +694,30 @@
                     p_media->b_raw = VLC_TRUE;
                 }
 
-                if( httpd_ClientIP( cl, ip ) == NULL )
+                if( strstr( psz_transport, "destination=" ) )
                 {
-                    answer->i_status = 500;
-                    answer->psz_status = strdup( "Internal server error" );
-                    answer->i_body = 0;
-                    answer->p_body = NULL;
-                    break;
+                    char *psz_destination;
+                    strcpy( ip, strstr( psz_transport, "destination=" ) +
+                            strlen( "destination=" ) );
+                    if( ( psz_destination = strstr( ip, ":" ) ) != NULL )
+                    {
+                        i_port = atoi( psz_destination + 1 );
+                        *psz_destination = '\0';
+                    }
+                    if( ( psz_destination = strstr( ip, ";" ) ) != NULL )
+                        *psz_destination = '\0';
                 }
+                else
+                {
+                    if( httpd_ClientIP( cl, ip ) == NULL )
+                    {
+                        answer->i_status = 500;
+                        answer->psz_status = strdup( "Internal server error" );
+                        answer->i_body = 0;
+                        answer->p_body = NULL;
+                        break;
+                    }
+                }
 
                 msg_Dbg( p_vod, "HTTPD_MSG_SETUP: unicast ip=%s port=%d",
                          ip, i_port );
@@ -729,6 +750,9 @@
                     }
                 }
 
+                p_rtsp->i_port = i_port;
+                p_rtsp->psz_ip = strdup( ip );
+
                 answer->i_status = 200;
                 answer->psz_status = strdup( "OK" );
                 answer->i_body = 0;
@@ -794,8 +818,13 @@
             }
             else if( p_rtsp->b_playing ) break;
 
-            if( httpd_ClientIP( cl, ip ) == NULL ) break;
+            if( p_rtsp->psz_ip ) 
+                strcpy( ip, p_rtsp->psz_ip );
+            else 
+                if( httpd_ClientIP( cl, ip ) == NULL ) break;
 
+            if( p_rtsp->i_port ) i_port = p_rtsp->i_port;
+
             p_rtsp->b_playing = VLC_TRUE;
 
             /* FIXME for != 1 video and 1 audio */
@@ -805,6 +834,8 @@
                     i_port_audio = p_rtsp->es[i]->i_port;
                 if( p_rtsp->es[i]->p_media_es->fmt.i_cat == VIDEO_ES )
                     i_port_video = p_rtsp->es[i]->i_port;
+                if( p_rtsp->es[i]->psz_ip ) 
+                    strcpy( ip, p_rtsp->es[i]->psz_ip );
             }
 
             if( p_media->psz_mux )
@@ -950,14 +981,32 @@
                 int i_port = atoi( strstr( psz_transport, "client_port=" ) +
                                 strlen("client_port=") );
 
-                if( httpd_ClientIP( cl, ip ) == NULL )
+                if( strstr( psz_transport, "destination=" ) )
                 {
-                    answer->i_status = 500;
-                    answer->psz_status = strdup( "Internal server error" );
-                    answer->i_body = 0;
-                    answer->p_body = NULL;
-                    break;
+                    char *psz_destination;
+                    strcpy( ip, strstr( psz_transport, "destination=" ) +
+                            strlen( "destination=" ) );
+                    if( ( psz_destination = strstr( ip, ":" ) ) != NULL )
+                    {
+                        i_port = atoi( psz_destination + 1 );
+                        *psz_destination = '\0';
+                    }
+                    if( ( psz_destination = strstr( ip, ";" ) ) != NULL )
+                    {
+                        *psz_destination = '\0';
+                    }
                 }
+                else
+                {
+                    if( httpd_ClientIP( cl, ip ) == NULL )
+                    {
+                        answer->i_status = 500;
+                        answer->psz_status = strdup( "Internal server error" );
+                        answer->i_body = 0;
+                        answer->p_body = NULL;
+                        break;
+                    }
+                }
 
                 msg_Dbg( p_vod, "HTTPD_MSG_SETUP: unicast ip=%s port=%d",
                         ip, i_port );
